/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.showtitleinfo
 *  fire.msp.title.GNotifyTitle
 *  fire.pb.GsClient
 *  fire.pb.PropRole
 *  fire.pb.attr.SRefreshRoleData
 *  fire.pb.effect.Module
 *  fire.pb.item.Equip
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.skill.Result
 *  fire.pb.skill.SkillRole
 *  fire.pb.talk.MessageMgr
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  xbean.Pod
 *  xbean.Properties
 *  xbean.TitleInfo
 *  xtable.Properties
 */
package fire.pb.title;

import fire.msp.showtitleinfo;
import fire.msp.title.GNotifyTitle;
import fire.pb.GsClient;
import fire.pb.PropRole;
import fire.pb.attr.SRefreshRoleData;
import fire.pb.effect.Module;
import fire.pb.item.Equip;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.skill.Result;
import fire.pb.skill.SkillRole;
import fire.pb.talk.MessageMgr;
import fire.pb.title.COffTitle;
import fire.pb.title.PAddTitleProc;
import fire.pb.title.PRemoveTitleProc;
import fire.pb.title.SAddTitle;
import fire.pb.title.SRemoveTitle;
import fire.pb.title.STitleConfig;
import fire.pb.title.STitleErr;
import fire.pb.title.TitleInfo;
import fire.pb.title.TitleManager;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import xbean.Pod;
import xtable.Properties;

public class Title {
    private long roleid;
    public static ConcurrentHashMap<Long, Long> titleroleids = new ConcurrentHashMap();
    private final xbean.Properties prop;
    private boolean readonly;
    private static final int maxtitlesnum = 200;

    public Title(long roleid, boolean readonly) {
        this.roleid = roleid;
        this.readonly = readonly;
        this.prop = !readonly ? Properties.get((Long)roleid) : Properties.select((Long)roleid);
        this.roleid = roleid;
        this.readonly = readonly;
    }

    public boolean roleHaveTitle(int titleid) {
        Map titles = this.prop.getTitles();
        return titles != null && titles.containsKey(titleid);
    }

    public boolean roleOnTitle() {
        return this.prop.getTitle() >= 0;
    }

    public boolean roleOnTitle(int titleid) {
        if (titleid < 0) {
            return false;
        }
        return this.prop.getTitle() == titleid;
    }

    public int getRoleOnTitle() {
        return this.roleOnTitle() ? this.prop.getTitle() : 0;
    }

    public showtitleinfo getShowTitleInfo(int titleid) {
        showtitleinfo info = new showtitleinfo();
        if (titleid < 0) {
            return info;
        }
        if (this.prop.getTitles() == null) {
            return info;
        }
        xbean.TitleInfo titleinfo = (xbean.TitleInfo)this.prop.getTitles().get(titleid);
        if (titleinfo == null) {
            return info;
        }
        info.titleid = titleinfo.getTitleid();
        info.titlename = titleinfo.getTitlename();
        info.validtime = titleinfo.getAvailtime();
        return info;
    }

    public boolean canAddTitle() {
        if (this.prop.getTitles() != null) {
            return this.prop.getTitles().size() < 200;
        }
        return false;
    }

    public boolean addTitle(int titleid, String name, long time) {
        TitleInfo info;
        if (this.readonly) {
            throw new RuntimeException("不能在存储过程外调用此函数!");
        }
        if (time < -1L) {
            throw new RuntimeException("调用加称谓接口，参数不合法");
        }
        STitleConfig titleconfig = TitleManager.getTitleConfigById(titleid);
        if (titleconfig == null) {
            this.psendTitleErrWhileRollback(-2);
            return false;
        }
        if (!this.canAddTitle()) {
            this.psendTitleErrWhileRollback(-3);
            return false;
        }
        if (this.roleHaveTitle(titleid)) {
            return false;
        }
        xbean.TitleInfo value = Pod.newTitleInfo();
        value.setTitleid(titleid);
        if (name != null) {
            value.setTitlename(name);
        } else {
            value.setTitlename("");
        }
        long now = Calendar.getInstance().getTimeInMillis();
        if (time <= 0L) {
            if (titleconfig.availtime == -1) {
                value.setAvailtime(-1L);
            } else {
                value.setAvailtime((long)titleconfig.availtime * 1000L + now);
            }
        } else {
            value.setAvailtime(now + time);
        }
        this.prop.getTitles().put(titleid, value);
        if (titleconfig.availtime > 0) {
            titleroleids.put(this.roleid, this.roleid);
        }
        SAddTitle addTitle = new SAddTitle();
        addTitle.info = info = new TitleInfo(titleid, value.getTitlename(), value.getAvailtime());
        Procedure.psendWhileCommit((long)this.roleid, (Protocol)addTitle);
        Equip itemBases = new Equip(this.roleid, false);
        itemBases.resheffect();
        GNotifyTitle send = new GNotifyTitle();
        send.roleid = this.roleid;
        send.title = this.getShowTitleInfo(titleid);
        GsClient.pSendWhileCommit((Protocol)send);
        HashMap<Integer, Integer> sExtSkill = new HashMap<Integer, Integer>();
        ArrayList<Integer> skilllist = titleconfig.getSkills();
        if (skilllist != null && !skilllist.isEmpty()) {
            for (int skillid : skilllist) {
                sExtSkill.put(skillid, 1);
            }
        }
        SkillRole skillRole = new SkillRole(this.roleid);
        Result r = skillRole.UpdateExtBuff(sExtSkill, true);
        SRefreshRoleData snd = new SRefreshRoleData();
        snd.datas.putAll(Module.getClientAttrs((Map)r.getChangedAttrs()));
        Procedure.psendWhileCommit((long)this.roleid, (Protocol)snd);
        if (titleconfig.getSkills1() != null && titleconfig.getSkills1().size() > 0) {
            HashMap<Integer, Integer> SExtSkill = new HashMap<Integer, Integer>();
            int index = 0;
            PropRole pRole = new PropRole(this.roleid, false);
            skillRole.removeExtSkill();
            for (int skillid : titleconfig.getSkills1()) {
                if (titleconfig.getSkillfactors().size() > index && titleconfig.getSkillconstants().size() > index) {
                    int nlv = titleconfig.getSkillfactors().get(index) * pRole.getLevel() + titleconfig.getSkillconstants().get(index);
                    SExtSkill.put(skillid, nlv);
                }
                ++index;
            }
            skillRole.addExtSkillWithSP(SExtSkill);
        }
        return true;
    }

    public static void addTitle(long roleid, int titleid, String name, long time) {
        PAddTitleProc addproc = new PAddTitleProc(roleid, titleid, name, time);
        if (Transaction.current() == null) {
            addproc.submit();
        } else {
            addproc.call();
        }
    }

    public static boolean hasTitle(long roleid, int titleid) {
        xbean.Properties properties = Properties.select((Long)roleid);
        if (properties != null) {
            Map titles = properties.getTitles();
            return titles != null && titles.containsKey(titleid);
        }
        return false;
    }

    public boolean removeTitle(int titleid) {
        if (this.readonly) {
            throw new RuntimeException("不能在存储过程外调用此函数!");
        }
        if (!this.prop.getTitles().containsKey(titleid)) {
            return true;
        }
        if (this.prop.getTitle() == titleid) {
            this.prop.setTitle(-1);
            GNotifyTitle send = new GNotifyTitle();
            send.roleid = this.roleid;
            GsClient.pSendWhileCommit((Protocol)send);
        }
        this.prop.setEquipeffect(0);
        Equip itemBases = new Equip(this.roleid, false);
        itemBases.resheffect();
        this.prop.getTitles().remove(titleid);
        SRemoveTitle removeSend = new SRemoveTitle(titleid);
        Procedure.psendWhileCommit((long)this.roleid, (Protocol)removeSend);
        return true;
    }

    public static void removeTitle(long roleid, int titleid) {
        PRemoveTitleProc removeproc = new PRemoveTitleProc(roleid, titleid);
        if (Transaction.current() == null) {
            removeproc.submit();
        } else {
            removeproc.call();
        }
    }

    public static void changeTitle(long roleid, int titleid, String name, long time, boolean isOnTitle) {
        Title title = new Title(roleid, false);
        title.removeTitle(titleid);
        title.addTitle(titleid, name, time);
        if (isOnTitle) {
            title.onTitle(titleid);
        }
    }

    public boolean onTitle(int titleid) {
        if (this.readonly) {
            throw new RuntimeException("不能在存储过程外调用此函数");
        }
        xbean.TitleInfo titleinfo = (xbean.TitleInfo)this.prop.getTitles().get(titleid);
        if (titleinfo == null) {
            this.psendTitleErrWhileRollback(-4);
            return false;
        }
        int oldtitle = this.prop.getTitle();
        if (oldtitle > 0 && this.prop.getTitle() == titleid) {
            return false;
        }
        this.prop.setTitle(titleid);
        GNotifyTitle send = new GNotifyTitle();
        send.roleid = this.roleid;
        send.title = this.getShowTitleInfo(titleid);
        GsClient.pSendWhileCommit((Protocol)send);
        return true;
    }

    public boolean offTitle() {
        if (this.readonly) {
            throw new RuntimeException("不能在存储过程外使用此函数");
        }
        if (this.prop.getTitle() < 0) {
            return false;
        }
        this.prop.setTitle(-1);
        GNotifyTitle send = new GNotifyTitle();
        send.roleid = this.roleid;
        GsClient.pSendWhileCommit((Protocol)send);
        return true;
    }

    public boolean checkUpdateTitle() {
        if (this.readonly) {
            return false;
        }
        PropRole prole = new PropRole(this.roleid, true);
        Role role = RoleManager.getInstance().getRoleByID(this.roleid);
        if (role != null && COffTitle.isLiveDieTitle(prole)) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)162120, null);
            return false;
        }
        return true;
    }

    public void psendTitleErrWhileRollback(int errType) {
        STitleErr senderr = new STitleErr(errType);
        Procedure.psendWhileRollback((long)this.roleid, (Protocol)senderr);
    }
}

